TokenMaker
Date: 2017-02-11

org.fife.ui.rsyntaxtextarea

## Interface TokenMaker

- All Known Implementing Classes:
    AbstractJFlexCTokenMaker, AbstractJFlexTokenMaker, AbstractMarkupTokenMaker, AbstractTokenMaker, ActionScriptTokenMaker, AssemblerX86TokenMaker, BBCodeTokenMaker, ClojureTokenMaker, CPlusPlusTokenMaker, CSharpTokenMaker, CSSTokenMaker, CTokenMaker, DartTokenMaker, DelphiTokenMaker, DtdTokenMaker, DTokenMaker, FortranTokenMaker, GroovyTokenMaker, HtaccessTokenMaker, HTMLTokenMaker, JavaScriptTokenMaker, JavaTokenMaker, JshintrcTokenMaker, JsonTokenMaker, JSPTokenMaker, LatexTokenMaker, LessTokenMaker, LispTokenMaker, LuaTokenMaker, MakefileTokenMaker, MxmlTokenMaker, NSISTokenMaker, PerlTokenMaker, PHPTokenMaker, PlainTextTokenMaker, PropertiesFileTokenMaker, PythonTokenMaker, RubyTokenMaker, SASTokenMaker, ScalaTokenMaker, SQLTokenMaker, TclTokenMaker, TokenMakerBase, UnixShellTokenMaker, VisualBasicTokenMaker, WindowsBatchTokenMaker, XMLTokenMaker

      public interface TokenMaker

  An implementation of `TokenMaker` is a class that turns text into a linked list of `Token`s for syntax highlighting in a particular language.
  See Also:
    `Token`, `AbstractTokenMaker`

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addNullToken()` Adds a null token to the end of the current linked list of tokens.
    `void` | `addToken(char[] array, int start, int end, int tokenType, int startOffset)` Adds the token specified to the current linked list of tokens.
    `int` | `getClosestStandardTokenTypeForInternalType(int type)` Returns the closest `"standard" token type` for a given "internal" token type (e.g.
    `boolean` | `getCurlyBracesDenoteCodeBlocks(int languageIndex)` Returns whether this programming language uses curly braces ('`{`' and '`}`') to denote code blocks.
    `javax.swing.Action` | `getInsertBreakAction()` Returns an action to handle "insert break" key presses (i.e.
    `int` | `getLastTokenTypeOnLine(javax.swing.text.Segment text, int initialTokenType)` Returns the last token on this line's type if the token is "unfinished", or `TokenTypes.NULL` if it was finished.
    `java.lang.String[]` | `getLineCommentStartAndEnd(int languageIndex)` Returns the text to place at the beginning and end of a line to "comment" it in this programming language.
    `boolean` | `getMarkOccurrencesOfTokenType(int type)` Returns whether tokens of the specified type should have "mark occurrences" enabled for the current programming language.
    `OccurrenceMarker` | `getOccurrenceMarker()` Returns the object in charge of marking all occurrences of the token at the current caret position, if it is a relevant token.
    `boolean` | `getShouldIndentNextLineAfter(Token token)` If a line ends in the specified token, this method returns whether a new line inserted after that line should be indented.
    `Token` | `getTokenList(javax.swing.text.Segment text, int initialTokenType, int startOffset)` Returns the first token in the linked list of tokens generated from `text`.
    `boolean` | `isIdentifierChar(int languageIndex, char ch)` Returns whether a character could be part of an "identifier" token in a specific language.
    `boolean` | `isMarkupLanguage()` Returns whether this language is a markup language.

- - ### Method Detail

    - #### addNullToken

          void addNullToken()

      Adds a null token to the end of the current linked list of tokens. This should be put at the end of the linked list whenever the last token on the current line is NOT a multi-line token.

    - #### addToken

          void addToken(char[] array,
                      int start,
                      int end,
                      int tokenType,
                      int startOffset)

      Adds the token specified to the current linked list of tokens.
      Parameters:
        `array` - The character array from which to get the text.
        `start` - Start offset in `segment` of token.
        `end` - End offset in `segment` of token.
        `tokenType` - The token's type.
        `startOffset` - The offset in the document at which this token occurs.

    - #### getClosestStandardTokenTypeForInternalType

          int getClosestStandardTokenTypeForInternalType(int type)

      Returns the closest `"standard" token type` for a given "internal" token type (e.g. one whose value is `< 0`).
      Parameters:
        `type` - The token type.
      Returns:
        The closest "standard" token type. If a mapping is not defined for this language, then `type` is returned.

    - #### getCurlyBracesDenoteCodeBlocks

          boolean getCurlyBracesDenoteCodeBlocks(int languageIndex)

      Returns whether this programming language uses curly braces ('`{`' and '`}`') to denote code blocks.
      Parameters:
        `languageIndex` - The language index at the offset in question. Since some `TokenMaker`s effectively have nested languages (such as JavaScript in HTML), this parameter tells the `TokenMaker` what sub-language to look at.
      Returns:
        Whether curly braces denote code blocks.

    - #### getLastTokenTypeOnLine

          int getLastTokenTypeOnLine(javax.swing.text.Segment text,
                                   int initialTokenType)

      Returns the last token on this line's type if the token is "unfinished", or `TokenTypes.NULL` if it was finished. For example, if C-style syntax highlighting is being implemented, and `text` contained a line of code that contained the beginning of a comment but no end-comment marker ("*\/"), then this method would return `TokenTypes.COMMENT_MULTILINE` for that line. This is useful for doing syntax highlighting.
      Parameters:
        `text` - The line of tokens to examine.
        `initialTokenType` - The token type to start with (i.e., the value of `getLastTokenTypeOnLine` for the line before `text`).
      Returns:
        The last token on this line's type, or `TokenTypes.NULL` if the line was completed.

    - #### getLineCommentStartAndEnd

          java.lang.String[] getLineCommentStartAndEnd(int languageIndex)

      Returns the text to place at the beginning and end of a line to "comment" it in this programming language.
      Parameters:
        `languageIndex` - The language index at the offset in question. Since some `TokenMaker`s effectively have nested languages (such as JavaScript in HTML), this parameter tells the `TokenMaker` what sub-language to look at.
      Returns:
        The start and end strings to add to a line to "comment" it out. A `null` value for either means there is no string to add for that part. A value of `null` for the array means this language does not support commenting/uncommenting lines.

    - #### getInsertBreakAction

          javax.swing.Action getInsertBreakAction()

      Returns an action to handle "insert break" key presses (i.e. Enter).
      Returns:
        The action, or `null` if the default action should be used.

    - #### getMarkOccurrencesOfTokenType

          boolean getMarkOccurrencesOfTokenType(int type)

      Returns whether tokens of the specified type should have "mark occurrences" enabled for the current programming language.
      Parameters:
        `type` - The token type.
      Returns:
        Whether tokens of this type should have "mark occurrences" enabled.

    - #### getOccurrenceMarker

          OccurrenceMarker getOccurrenceMarker()

      Returns the object in charge of marking all occurrences of the token at the current caret position, if it is a relevant token. If `null` is returned, a default `OccurrenceMarker` is used.
      Returns:
        The occurrence marker for this language, or `null` for none.

    - #### getShouldIndentNextLineAfter

          boolean getShouldIndentNextLineAfter(Token token)

      If a line ends in the specified token, this method returns whether a new line inserted after that line should be indented.
      Parameters:
        `token` - The token the previous line ends with.
      Returns:
        Whether the next line should be indented.

    - #### getTokenList

          Token getTokenList(javax.swing.text.Segment text,
                           int initialTokenType,
                           int startOffset)

      Returns the first token in the linked list of tokens generated from `text`. This method must be implemented by subclasses so they can correctly implement syntax highlighting.
      Parameters:
        `text` - The text from which to get tokens.
        `initialTokenType` - The token type we should start with.
        `startOffset` - The offset into the document at which `text` starts.
      Returns:
        The first `Token` in a linked list representing the syntax highlighted text.

    - #### isIdentifierChar

          boolean isIdentifierChar(int languageIndex,
                                 char ch)

      Returns whether a character could be part of an "identifier" token in a specific language. This is used to identify such things as the bounds of the "word" to select on double-clicking.
      Parameters:
        `languageIndex` - The language index the character was found in.
        `ch` - The character.
      Returns:
        Whether the character could be part of an "identifier" token.

    - #### isMarkupLanguage

          boolean isMarkupLanguage()

      Returns whether this language is a markup language.
      Returns:
        Whether this language is markup.